/* 
  Spaceship - by The Last Viking  (C) 13. May 1997 Ekran Design.
  using ncurses...

  compile with: gcc -O -lncurses -lm spaceship.c -ospaceship
*/

#include <ncurses.h>
#include <stdlib.h>
#include <math.h> 

#define false 1
#define true 0

int xite,cnt,cntl,lcnt,sc,gover,sc,hiscore,padx;
int field[52][2];
char ch;
struct _win_st wp;

int rnd(int i) {return (1+(int)(((float)i*rand())/(RAND_MAX-1)+1));}

void intro(void) {

 int xintr;
 int x,y,x2,y2,xo,yo;
 double dcnt,xd,yd;

 xintr=false;
 xo=0; yo=0;
 dcnt=0; cnt=0;
  do {
    if (cnt==1250) {cnt=0;dcnt=0;}
    mvprintw(8,35,"SPACESHIP");
    mvprintw(10,20,"Written by The Last Viking 13. May 1997");
    mvprintw(12,19,"Guide your spaceship through the asteroid");
    mvprintw(13,25,"field using the z or the x key");
    mvprintw(14,26,"Use E to exit and S to start");
    mvprintw(16,32,"Last score: %d",sc);
    if (hiscore<sc) hiscore=sc;
    mvprintw(17,31,"Highest score: %d",hiscore);
    dcnt=dcnt+0.005;  /* circles the spaceship intro */
    xd=(cos(dcnt)*30);
    yd=(sin(dcnt)*12);
    x=35+(int)xd;
    y=12+(int)yd;
    x2=35-(int)xd;
    y2=12-(int)yd;
    if ((x2!=xo) || (y2!=yo)) mvprintw(yo,xo-1,"           ");
    mvprintw(y,x,"SPACESHIP"); 
    xo=x2;yo=y2; 
    ch='a';
    ch=(char)getch();
    if (ch=='s') {xintr=true; xite=false; gover=false;}
    if (ch=='e') {xintr=true; xite=true; gover=false;}
    timeout(0);
  } while (xintr==false);
}

void field_handler(void) { /* field handler - moves-draws-detect collision */
 if (lcnt<50) {field[lcnt][1]=rnd(78); lcnt++;}
 for (cnt=0;cnt<lcnt; cnt++) {
   mvprintw(field[cnt][0],field[cnt][1]," ");
   field[cnt][0]++;
   if (field[cnt][0]>24) {field[cnt][0]=0; field[cnt][1]=rnd(78);}
   mvprintw(field[cnt][0],field[cnt][1],"*");
   if ((field[cnt][0]==20) && ((field[cnt][1]==padx) || 
      (field[cnt][1]==padx+1) || (field[cnt][1]==padx+2))) gover=true; 
 }
}

void keys(void) { /* control an draw the spaceship */
  ch=(char)getch();
  if (((ch=='z') || (ch=='Z')) && (padx>1)) {mvprintw(20,padx,"   ");padx--;}
  if (((ch=='x') || (ch=='X')) && (padx<76)) {mvprintw(20,padx,"   ");padx++;}
  if (ch=='q') gover=true;
  if (ch=='e') xite=true;
  mvprintw(20,padx,"<*>");
}

void main(void) {

 wp=*initscr(); /* initialize curses */
 cbreak();
 noecho();
 nonl();
 intrflush(stdscr, FALSE);
 keypad(stdscr, TRUE);
 nodelay(stdscr,TRUE);
 curs_set(0);

 hiscore=0;
 do {
   clear();
   intro();
   clear();
   sc=0; lcnt=0; cnt=0;
   ch='.'; padx=38;
   for (cnt=0; cnt<50; cnt++) {field[cnt][0]=0;field[cnt][1]=0;}
   do {
     keys();
     field_handler();
     sc++;
     timeout(25+(150-sc));
   } while ((gover==false) && (xite==false));
 } while (xite==false);

 clear();
 printw("bye.");
 wrefresh(&wp);
 endwin();
}

